
import{world as w, system}from"@minecraft/server";
export var register={
	class: "Anceint Script Console",
	"identifier": "mythbreak:ancient_script",
	"console": {
		"open": "holder",
		"read-only": false,
		"forcedDisplay": false,
		"ui-type": "default",
		"admin-only": true
	}
}
import { MessageFormData as alert } from "@minecraft/server-ui"
function errorPage(target, error) {
	var pageError=new alert()
		.title("%Error%")
		.body(`${error}`)
		.button1("Cancle Event!")
		.button2("Keep run!")
		
	pageError.show(target)
}
import { ModalFormData as consolePage } from "@minecraft/server-ui"
system.runInterval(function(){
	for(let p of w.getPlayers()){
		if(p.hasTag("scriptConsole")) {
			var consoleUi=new consolePage()
				.title("Console Panel")
				.textField("Enter Code", "§kNative Script")
				
				
			consoleUi.show(p).then((r)=>{
				p.removeTag("scriptConsole")
				try {
					scriptReader(p, r.formValues)
					p.removeTag("scriptConsole")
				} catch(e) {
					console.warn(e + e.stack)
				}
			})
		}
	}
}, 5)

function scriptReader(target, allScripts) {
	let scripts=allScripts[0];
	let scriptsArray=scripts.split(";");
	for(let line=0;line<scriptsArray.length;line++) {
		if(scriptsArray[line].includes("function")) return functionScript(target, scriptsArray[line]);
		if(scriptsArray[line].includes("call")) return callScript(target, scriptsArray[line]);
		if(scriptsArray[line].includes("self")) return selfScript(target, scriptsArray[line]);
	}
}

function functionScript(target, script) {
	try{
		script();
	} catch(e) {
		throw errorPage(target, e + e.stack)
	}
}

function callScript(target, script) {
	var usage= "call:function:"
	var callingFunction=script.split(":")[1]
	if(callingFunction.includes("module")) {
		var module=callingFunction.split(":")[1]
		import(`${module}`).then((module)=>{
			functionScript(target, function(){module.register()})
		})
	} else {
		throw errorPage(target, "For now only Support 'call:module'!")
	}
}

function selfScript(target, scriptAA) {
	var callingFunctionSelf=scriptAA.split(".")[1]
	if(callingFunctionSelf.includes("give")) {
		var giveUsage= "self.give(idItem,amount,data)"
		var giveFunction=callingFunctionSelf.split("(")[1]
		var giveFunctionFollowers=giveFunction.split(")")[1]
		var item=giveFunction.split(",")
		functionScript(target, function(){target.runCommandAsync(`give @s ${item[0]} ${item[1]} ${item[2]}`)})
	} else if(callingFunctionSelf.includes("Command")) {
		var commandUsage="self.Command(say p)"
		var commandFunctionSplit=callingFunctionSelf.split("(")[1]
		var commandFunction=commandFunctionSplit.split(")")[0]
		functionScript(target, function(){target.runCommandAsync(`${commandFunction}`)})
		
	} else if(callingFunctionSelf.includes("setOp")) {
		var commandUsage="self.setOp"
		functionScript(target, function(){target.setOp()})
	} else throw errorPage(target, "Now only support 'self.give'!")
}


/*examForMakingModule
	function register() {         //must have register function!
		callAnyFunction()
	}
*/