
import{world as w}from"@minecraft/server";
export var register={
	class: "Rotten Apple Ticking",
	"identifier": "minecraft:apple",
	"keep_amount": true,
	"keep_data": true,
	"aliases": [
		"minecraft:apple",
		"mythbreak:rotten_apple_0",
		"mythbreak:rotten_apple_1",
		"mythbreak:rotten_apple_2"
	],
	"on_start": {
		"v.rotten_level": 0
	},
	"minecraft:timer": [
		{
			"filters": ["v.rotten_level", "==", 0],
			"timer": [
				{"minutes": 10},
				{"seconds": 0}
			],
			"showInDescribtion": true,
			"on_tick": {
				"v.rotten_level": 1
			}
		},
		{
			"filters": ["v.rotten_level", "==", 1],
			"timer": [
				{"minutes": 2},
				{"seconds": 0}
			],
			"showInDescribtion": true,
			"on_tick": {
				"v.rotten_level": 2
			}
		},
		{
			"filters": ["v.rotten_level", "==", 2],
			"timer": [
				{"minutes": 2},
				{"seconds": 0}
			],
			"showInDescribtion": true,
			"on_tick": {
				"v.rotten_level": 3
			}
		},
		{
			"filters": ["v.rotten_level", "==", 3],
			"timer": [
				{"minutes": 1},
				{"seconds": 0}
			],
			"showInDescribtion": true,
			"on_tick": {
				"v.rotten_level": 4
			}
		}
	]
}

var nowTick=0
function transformAppleRotten(target, slot, amount, level) {
	if(level==0) {
		try {
			target.runCommandAsync(`replaceItem entity @s ${slot > 8 ? "slot.inventory" : "slot.hotbar"} ${slot > 8 ? Number(slot) - Number(9) : slot} mythbreak:rotten_apple_0 ${amount ? amount : 0}`)
		} catch(e) {
			errorPage(target, e + e.stack)
		}
	} else if(level==1) {
		try {
			target.runCommandAsync(`replaceItem entity @s ${slot > 8 ? "slot.inventory" : "slot.hotbar"} ${slot > 8 ? Number(slot) - Number(9) : slot} mythbreak:rotten_apple_1 ${amount ? amount : 0}`)
		} catch(e) {
			errorPage(target, e + e.stack)
		}
	} else if(level==2) {
		try {
			target.runCommandAsync(`replaceItem entity @s ${slot > 8 ? "slot.inventory" : "slot.hotbar"} ${slot > 8 ? Number(slot) - Number(9) : slot} mythbreak:rotten_apple_2 ${amount ? amount : 0}`)
		} catch(e) {
			errorPage(target, e + e.stack)
		}
	} else {
		try {
			target.runCommandAsync(`replaceItem entity @s ${slot > 8 ? "slot.inventory" : "slot.hotbar"} ${slot > 8 ? Number(slot) - Number(9) : slot} mythbreak:rotten_apple ${amount ? amount : 0}`)
		} catch(e) {
			errorPage(target, e + e.stack)
		}
	}
}
import{system as s}from"@minecraft/server";
system.runInterval(function(){
	var dimensions = [w.getDimension("overworld"), w.getDimension("nether"), w.getDimension("the end")]
	for(let dim of dimensions) {
		const entities = dim.getEntities()
		for(let entity of entities) {
			if(entity && entity.typeId) {
				if(entity.typeId == "minecraft:sheep") {
				
				}
			}
		}
	}
	for(let p of w.getPlayers()){
		var playerContainer=p.getComponent("minecraft:inventory").container;
		for(let playerSlot=0;playerSlot<playerContainer.size;playerSlot++) {
			var playerItem=playerContainer.getItem(playerSlot)
			if(playerItem) {
				if(register.aliases.includes(playerItem.typeId)) {
					if(!playerItem.getLore()[0]) {
						var appleDate=new Date()
						var appleRottenDateIn=new Date(appleDate.getFullYear(), appleDate.getMonth(), appleDate.getDate(), appleDate.getHours(), appleDate.getMinutes() + 10, appleDate.getSeconds())
						const Month = ["January","February","March","April","May","June","July","August","September","October","November","December"];
						if(playerItem.typeId=="minecraft:apple") {
							playerItem.setLore([`§r§fApple will §crotten§r§f in [2:0]`])
						} else if(playerItem.typeId=="mythbreak:rotten_apple_0") {
							playerItem.setLore([`§r§fApple will §crotten§r§f in [1:0]`])
						} else if(playerItem.typeId=="mythbreak:rotten_apple_1") {
							playerItem.setLore([`§r§fApple will §crotten§r§f in [0:60]`])
						}  else if(playerItem.typeId=="mythbreak:rotten_apple_2") {
							playerItem.setLore([`§r§fApple will §crotten§r§f in [0:60]`])
						}
						playerContainer.setItem(playerSlot, playerItem)
					} else {
						nowTick++;
						if(nowTick > 35) {
							var appleRottenDateArray=playerItem.getLore()
							var appleRottenDate=appleRottenDateArray.toString().split("[")[1].replace("]", "")
							var appleRottenDateMinutes=Number(appleRottenDate.split(":")[0])
							var appleRottenDateSeconds=Number(appleRottenDate.split(":")[1])
							appleRottenDateSeconds--;
							if(appleRottenDateSeconds>60) {
								appleRottenDateMinutes++;
								appleRottenDateSeconds=0;
							} else if(appleRottenDateSeconds<1) {
								if(appleRottenDateMinutes<1) {
									if(playerItem.typeId=="mythbreak:rotten_apple_2") transformAppleRotten(p, playerSlot, playerItem.amount, 3);
									if(playerItem.typeId=="mythbreak:rotten_apple_1") transformAppleRotten(p, playerSlot, playerItem.amount, 2);
									if(playerItem.typeId=="mythbreak:rotten_apple_0") transformAppleRotten(p, playerSlot, playerItem.amount, 1);
									if(playerItem.typeId=="minecraft:apple") transformAppleRotten(p, playerSlot, playerItem.amount, 0);
								}
								appleRottenDateMinutes--;
								appleRottenDateSeconds=60;
							}
							
							playerItem.setLore([`§r§fApple will §crotten§r§f in [${appleRottenDateMinutes}:${appleRottenDateSeconds}]`])
							playerContainer.setItem(playerSlot, playerItem)
							nowTick=0;
						}
						/*var appleRottenDate=appleRottenDateArray.spli("[")[1].replace("]", "");
						var appleRottenDateYear=appleRottenDate.split(",")[0];
						var appleRottenDateMonthName=appleRottenDate.split(",")[1];
						var appleRottenDateMonth=getMonthIndex(appleRottenDateMonthName)
						var appleRottenDateDate=appleRottenDate.split(",")[2];
						var appleRottenDateTime=appleRottenDate.split(",")[3];
						var nowPlayerAppleDate=new Date()
						if(nowPlayerAppleDate.getFullYear() !== appleRottenDateYear) return;
						if(nowPlayerAppleDate.getMonth() !== appleRottenDateYear) return;
						if(nowPlayerAppleDate.getDate() !== appleRottenDateYear) return;*/
					}
				}
			}
		}
	}
}, 1)

import { MessageFormData as alert } from "@minecraft/server-ui"
function errorPage(target, error) {
	var pageError=new alert()
		.title("%Error%")
		.body(`${error}`)
		.button1("Cancle Event!")
		.button2("Keep run!")
		
	pageError.show(target)
}


function setTickInterval(callback,tick) {
	var thisTick=0;
	w.events.tick.subscribe((event) =>{
		thisTick++
		if(thisTick !== tick) return;
		callback();
		thisTick=0;
	})
}





